@ECHO OFF
SET SCE_PSM_SDK=%CD%\support\psm
SET SCE_PSM_UNITY=%CD%\support\unity

:init
CLS
COLOR 2F
ECHO Rejuvenate Setup
ECHO(
ECHO You only need to run this script once. However, you can run this script again
ECHO to set up a different version of PSM.
ECHO(
PAUSE

:getfiles
CLS
SET USE_PSM=n
SET USE_UNITY=n

SET /P USE_UNITY=Are you installing for PSM Unity? [y/n] (default - n)?:

:checkfortoolset
IF "%USE_UNITY%"=="y" (
    IF EXIST "support\unity\tools\lib\host_transport32.dll" GOTO installdriver
    IF EXIST "PSMToolSetForUnity_1.1.0.7.exe" GOTO extractfiles
    ECHO Please download "PSMToolSetForUnity_1.1.0.7.exe" and place it in this directory.
    ECHO(
    PAUSE
    IF NOT EXIST "PSMToolSetForUnity_1.1.0.7.exe" GOTO checkfortoolset
    GOTO extractfiles
)

SET /P USE_PSM=Are you installing for PSM Dev? [y/n] (default - n)?:

:checkforsdk
IF "%USE_PSM%"=="y" (
    IF EXIST "support\psm\tools\lib\host_transport32.dll" GOTO installdriver    
    IF EXIST "PSM_SDK_1.21.02.exe" GOTO extractfiles
    ECHO Please download "PSM_SDK_1.21.02.exe" and place it in this directory.
    ECHO(
    PAUSE
    IF NOT EXIST "PSM_SDK_1.21.02.exe" GOTO checkforsdk
    GOTO extractfiles
)

IF "%USE_PSM%"=="n" (
	IF "%USE_UNITY%"=="n" (
		GOTO exit
	)
)

:extractfiles
IF "%USE_PSM%"=="y" (
	IF EXIST support\psm\tools\PublishingUtility\PublishingUtility.exe (
		GOTO checkkeys
	)
	MKDIR support\psm 2> nul
	ECHO Extracting PSM files. Please wait...
	DEL /f /q support\psm\*.*
	START /WAIT support\7z.exe x -o"support\psm" -y "PSM_SDK_1.21.02.exe"

    COPY /Y "support\psm\$PROGRAMFILES\MSBuild\$PROGRAMFILES\MSBuild\Sce\psm_encrypter32.dll" "support\psm\tools\lib\psm_encrypter32.dll"
    COPY /Y "support\psm\$PROGRAMFILES\MSBuild\$PROGRAMFILES\MSBuild\Sce\psm_encrypter64.dll" "support\psm\tools\lib\psm_encrypter64.dll"

	RMDIR /S /Q support\psm\$DOCUMENTS
	RMDIR /S /Q support\psm\$PLUGINSDIR
	RMDIR /S /Q support\psm\$PROGRAMFILES
)
IF "%USE_UNITY%"=="y" (
	IF EXIST support\unity\tools\PublishingUtility\PublishingUtilityForUnity.exe (
		GOTO checkkeys
	)
    MKDIR support\unity 2> nul
	ECHO Extracting PSM for Unity files. Please wait...
	DEL /f /q support\unity\*.*
    START /WAIT support\7z.exe x -o"support\unity" -y "PSMToolSetForUnity_1.1.0.7.exe"

	RMDIR /S /Q support\unity\$DOCUMENTS
	RMDIR /S /Q support\unity\$PLUGINSDIR

	IF EXIST "UnitySetup_update-4.3.7p3.exe" (
		START /WAIT support\7z.exe x -o"support\unity" -y "UnitySetup_update-4.3.7p3.exe"
	)
	IF EXIST "UnitySetup_update-4.3.4f1.exe" (
		START /WAIT support\7z.exe x -o"support\unity" -y "UnitySetup_update-4.3.4f1.exe"
	)
)
SET DPINST_TYPE=x86
IF EXIST "%systemroot%\sysnative\" set DPINST_TYPE=amd64
IF EXIST "%systemroot%\syswow64\" set DPINST_TYPE=amd64
IF "%USE_PSM%"=="y" (
	COPY /Y "support\psm\tools\vita\driver\dpinst\%DPINST_TYPE%\dpinst.exe" "support\dpinst.exe"
    COPY /Y "support\psm\tools\vita\driver\dpinst.xml" "support\dpinst.xml"
    COPY /Y "support\psm\tools\vita\driver\vita_usbser.cat" "support\vita_usbser.cat"
    COPY /Y "support\psm\tools\vita\driver\vita_usbser.inf" "support\vita_usbser.inf"
)
IF "%USE_UNITY%"=="y" (
    COPY /Y "support\unity\tools\PS_Vita\driver\dpinst\%DPINST_TYPE%\dpinst.exe" "support\dpinst.exe"
    COPY /Y "support\unity\tools\PS_Vita\driver\dpinst.xml" "support\dpinst.xml"
    COPY /Y "support\unity\tools\PS_Vita\driver\vita_usbser.cat" "support\vita_usbser.cat"
    COPY /Y "support\unity\tools\PS_Vita\driver\vita_usbser.inf" "support\vita_usbser.inf"
)

:installdriver
ECHO Installing driver for PSM...
support\dpinst.exe /SA /EL

:checkkeys
IF "%USE_PSM%"=="y" (
	IF NOT EXIST "kdev.p12" GOTO checkkeys2
	IF NOT EXIST "+asterisk+.khapp" GOTO checkkeys2
)
IF "%USE_UNITY%"=="y" (
	IF NOT EXIST "kdev.p12" GOTO checkkeys2
	IF NOT EXIST "_PSM_DEFAULT_.khapp" GOTO checkkeys2
)
GOTO getversion

:checkkeys2
IF "%USE_PSM%"=="y" (
	IF NOT EXIST "%APPDATA%\SCE\PSM Publishing Utility\HostAppsKey\+asterisk+.khapp" GOTO generatekeys
	COPY /Y "%APPDATA%\SCE\PSM Publishing Utility\PublisherKey\kdev.p12" "kdev.p12"
	COPY /Y "%APPDATA%\SCE\PSM Publishing Utility\HostAppsKey\+asterisk+.khapp" "+asterisk+.khapp"
)
IF "%USE_UNITY%"=="y" (
	IF NOT EXIST "%APPDATA%\SCE\PSM Publishing Utility\HostAppsKey\_PSM_DEFAULT_.khapp" GOTO generatekeys
	COPY /Y "%APPDATA%\SCE\PSM Publishing Utility\PublisherKey\kdev.p12" "kdev.p12"
	COPY /Y "%APPDATA%\SCE\PSM Publishing Utility\HostAppsKey\_PSM_DEFAULT_.khapp" "_PSM_DEFAULT_.khapp"
)
ECHO Copied keys from Publishing Utility.
GOTO getversion

:generatekeys
CLS
ECHO Please import your PSM+ license files as stated on the PSM+ page.
PAUSE
IF "%USE_PSM%"=="y" (
	start /WAIT support\psm\tools\PublishingUtility\PublishingUtility.exe
	GOTO checkkeys
)
IF "%USE_UNITY%"=="y" (
	start /WAIT support\unity\tools\PublishingUtility\PublishingUtilityForUnity.exe
	GOTO checkkeys
)

:getversion
IF "%USE_PSM%"=="y" (
	CLS
	ECHO You need to specify the version of your PSM DevAssistant on the Vita
    ECHO To find this, go to LivaArea and find the icon for "PSM Dev"
	ECHO Press and hold the icon, then press the "..." next to the icon
	ECHO Select "Information" and look at what it says next to "Version"
	ECHO If your Vita is another language, translate accordingly
    ECHO(
)
IF "%USE_UNITY%"=="y" (
	CLS
	ECHO You need to specify the version of your PSM Unity DevAssistant on the Vita
    ECHO To find this, go to LivaArea and find the icon for "PSM Dev for Unity"
	ECHO Press and hold the icon, then press the "..." next to the icon
	ECHO Select "Information" and look at what it says next to "Version"
	ECHO If your Vita is another language, translate accordingly
    ECHO(
)

ECHO(
SET /P PSM_VERSION=Version:

IF "%USE_PSM%"=="y" (
	SET DEFILER_EXE="VitaDefiler-115.exe"
    IF "%PSM_VERSION%"=="1.15" SET DEFILER_EXE="VitaDefiler-115.exe"
    IF "%PSM_VERSION%"=="1.14" SET DEFILER_EXE="VitaDefiler-115.exe"
    IF "%PSM_VERSION%"=="1.11" SET DEFILER_EXE="VitaDefiler-111.exe"
)
IF "%USE_UNITY%"=="y" (
	SET DEFILER_EXE=
    IF "%PSM_VERSION%"=="1.05" SET DEFILER_EXE="VitaDefilerUnity.exe"
    IF "%PSM_VERSION%"=="1.06" SET DEFILER_EXE="VitaDefilerUnity.exe"
)

IF NOT "%DEFILER_EXE%"=="" GOTO copydefiler
ECHO Version '%PSM_VERSION%' is currently unsupported!
ECHO Using VitaDefiler for default version, however it will likely not work.
ECHO(
PAUSE

:copydefiler
IF "%USE_PSM%"=="y" (
	COPY /Y "vitadefiler\%DEFILER_EXE%" "VitaDefiler.exe"
)
IF "%USE_UNITY%"=="y" (
	COPY /Y "vitadefiler\%DEFILER_EXE%" "VitaDefilerUnity.exe"
)

:createpackage
CLS
ECHO Signing VitaDefiler client with keys...
IF "%USE_PSM%"=="y" (
	support\PsmSigner.exe "+asterisk+.khapp" "kdev.p12" "support\VitaDefilerClient" "VitaDefilerClient.psdp"
)
IF "%USE_UNITY%"=="y" (    
IF "%PSM_VERSION%"=="1.05" (
    support\PsmSigner_Unity.exe "_PSM_DEFAULT_.khapp" "kdev.p12" "support\VitaDefilerClientUnity_105" "VitaDefilerClient.psdp"
)
IF "%PSM_VERSION%"=="1.06" (
    support\PsmSigner_Unity.exe "_PSM_DEFAULT_.khapp" "kdev.p12" "support\VitaDefilerClientUnity_106" "VitaDefilerClient.psdp"
)
)

:copyscripts
IF "%USE_PSM%"=="y" (
	COPY "vitadefiler\run_homebrew.bat" run_homebrew.bat"
	COPY "vitadefiler\run_package_install.bat" "run_package_install.bat"
	COPY "vitadefiler\run_rpc.bat" "run_rpc.bat"
)
IF "%USE_UNITY%"=="y" (
	COPY "vitadefiler\run_homebrew_unity.bat" run_homebrew_unity.bat"
	COPY "vitadefiler\run_package_install_unity.bat" "run_package_install_unity.bat"
	COPY "vitadefiler\run_rpc_unity.bat" "run_rpc_unity.bat"
)

:installprompt
SET INSTALL_NOW=n
SET /P INSTALL_NOW=Do you want to install VitaDefilerClient now? [y/n] (default - n)?:
IF "%INSTALL_NOW%"=="n" (
	GOTO done
)

:installpackage
IF "%USE_PSM%"=="y" (
	VitaDefiler.exe VitaDefilerClient.psdp -install
)
IF "%USE_UNITY%"=="y" (
	VitaDefilerUnity.exe VitaDefilerClient.psdp -install
)

:done
IF "%USE_PSM%"=="y" (
	CLS
	ECHO Done with Rejuvenate setup.
	ECHO(
	ECHO You may now delete "PSM_SDK_1.21.02.exe"
	ECHO(
	ECHO To install VitaDefilerClient, run "run_package_install.bat"
	ECHO To run homebrew, drag the homebrew ELF to "run_homebrew.bat"
	ECHO To run the RPC, run "run_rpc.bat"
	ECHO Enjoy!
	PAUSE
)
IF "%USE_UNITY%"=="y" (
	CLS
	ECHO Done with Rejuvenate setup.
	ECHO(
	ECHO You may now delete "PSMToolSetForUnity_1.1.0.7.exe"
	ECHO(
	ECHO To install VitaDefilerClient, run "run_package_install_unity.bat"
	ECHO To run homebrew, drag the homebrew ELF to "run_homebrew_unity.bat"
	ECHO To run the RPC, run "run_rpc_unity.bat"
	ECHO Enjoy!
	PAUSE
)

:exit
